unit SettingsUnit;
{
Mouse scroll setting(volume,video window size, speed control,)
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Registry;

type
  TSettingsForm = class(TForm)
    Bevel1: TBevel;
    OkButton: TButton;
    CancelButton: TButton;
    SaveWindowPositionsCheckBox: TCheckBox;
    DefaultDVDDriveComboBox: TComboBox;
    Label1: TLabel;
    SavePreviewWindowSizeCheckBox: TCheckBox;
    Label2: TLabel;
    MouseWheelComboBox: TComboBox;
    RemoveSettingsButton: TButton;
    MouseWheelFullScreenComboBox: TComboBox;
    Label3: TLabel;
    procedure CancelButtonClick(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SaveTempSettings();
    procedure RestoreTempSettings();
    procedure RemoveSettingsButtonClick(Sender: TObject);
   private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SettingsForm: TSettingsForm;
  SaveWindowPositionsTemp,
  SavePreviewWindowSizeTemp : Boolean;
  DefaultDVDDriveTemp        : string;
  MouseWheelFunctionTemp     : Byte;

implementation


uses Unit1, Unit2;

{$R *.dfm}

procedure TSettingsForm.CancelButtonClick(Sender: TObject);
begin
  SettingsForm.Hide;
  if SaveSettings = True then RestoreTempSettings();            //restore the temporary saved settings
                                              //if False then the settings have been deleted from the registry
end;

procedure TSettingsForm.OkButtonClick(Sender: TObject);
begin
  SaveSettings  := True;
  SettingsForm.Hide;
end;

procedure TSettingsForm.FormShow(Sender: TObject);
begin
  SaveTempSettings();           //Saved temporary. Restored if user clicks Cancel.
end;

procedure TSettingsForm.SaveTempSettings();       //Saved temporary. Restored if user clicks Cancel.
begin
  SaveWindowPositionsTemp    := SaveWindowPositionsCheckbox.Checked;
  SavePreviewWindowSizeTemp  := SavePreviewWindowSizeCheckbox.Checked;
  DefaultDVDDriveTemp        := DefaultDVDDriveCombobox.Text;
  MouseWheelFunctionTemp     := MouseWheelCombobox.ItemIndex;
end;

procedure TSettingsForm.RestoreTempSettings();       //user clicked Cancel, let's restore what we saved earlier
begin
  SaveWindowPositionsCheckbox.Checked     :=  SaveWindowPositionsTemp  ;
  SavePreviewWindowSizeCheckbox.Checked   :=  SavePreviewWindowSizeTemp;
  DefaultDVDDriveCombobox.Text            :=  DefaultDVDDriveTemp    ;
  MouseWheelCombobox.ItemIndex            :=  MouseWheelFunctionTemp ;
end;

procedure TSettingsForm.RemoveSettingsButtonClick(Sender: TObject);
var  Registry  : TRegistry;
begin
  Registry := TRegistry.Create();
  Registry.RootKey := HKEY_LOCAL_MACHINE;
  if Registry.KeyExists('SOFTWARE\A DVD Player') = True then begin
    if Registry.DeleteKey('SOFTWARE\A DVD Player') = False then
      MessageDlg('The registry values could not be deleted for some reason. Please remove the key "HKEY_LOCAL_MACHINE\SOFTWARE\A DVD Player" yourself by using RegEdit.', mtError,[mbOk], 0);
    SaveSettings  := False;                      //if false then prog does not save settings on Exit.
  end;
  Registry.Free;
end;

end.
