unit Unit1;
interface
{$IFDEF VER150}
  {$WARN UNSAFE_CODE OFF}
  {$WARN UNSAFE_TYPE OFF}
  {$WARN UNSAFE_CAST OFF}
{$ENDIF}

//open dvd files from HD directory


uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, DSPack, DirectShow9, shellapi, ImgList, DSUtil{used by GetErrorString},
  ToolWin, unit2{VideoWindowForm}, Buttons,InfoUnit, Menus,SettingsUnit, Registry,
  ExtCtrls, Mousebar, mmsystem, IniFiles, unit3{About FOrm};

type
  TMainForm = class(TForm)
    FilterGraph: TFilterGraph;
    ToolBar: TToolBar;
    PlayButton: TToolButton;
    PauseButton: TToolButton;
    StopButton: TToolButton;
    ImageList: TImageList;
    FullScreenButton: TToolButton;
    RootMenuButton: TToolButton;
    TitleMenuButton: TToolButton;
    OpenDialog: TOpenDialog;
    OpenButton: TToolButton;
    TitleLabel: TLabel;
    ChapterLabel: TLabel;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    PrevChapterButton: TToolButton;
    NextChapterButton: TToolButton;
    ToolButton12: TToolButton;
    SpeedTrackBar: TTrackBar;
    SettingsButton: TToolButton;
    ToolButton1: TToolButton;
    InfoButton: TToolButton;
    ToolButton2: TToolButton;
    VolumeTrackBar: TTrackBar;
    SpeedLabel: TLabel;
    VolumeLabel: TLabel;
    PopupMenu: TPopupMenu;
    Audiostreams: TMenuItem;
    Subtitlestreams1: TMenuItem;
    Information1: TMenuItem;
    ogglefullscreen1: TMenuItem;
    Menu1: TMenuItem;
    Root: TMenuItem;
    itle1: TMenuItem;
    Subtitles1: TMenuItem;
    Chapters1: TMenuItem;
    Angle1: TMenuItem;
    Audio1: TMenuItem;
    DrivesMenu: TPopupMenu;
    GroupBox1: TGroupBox;
    AudioButton: TToolButton;
    SubpictureButton: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    MuteButton: TToolButton;
    AudioButtonMenu: TPopupMenu;
    SubpicButtonMenu: TPopupMenu;
    dsTrackbar: TMousebar;
    Chapter1: TMenuItem;
    ToolButton5: TToolButton;
    EjectButton: TToolButton;
    TimeLabel: TLabel;
    EjectDriveMenu: TPopupMenu;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ChapterButton: TToolButton;
    ChapterButtonMenu: TPopupMenu;
    procedure PlayDVD(Sourcefile: WideString);
    procedure PlayButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure PauseButtonClick(Sender: TObject);
    procedure FullScreenButtonClick(Sender: TObject);
    procedure RootMenuButtonClick(Sender: TObject);
    procedure TitleMenuButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OpenButtonClick(Sender: TObject);
    procedure FilterGraphDVDTitleChange(sender: TObject; title: Integer);
    procedure FilterGraphDVDChapterStart(sender: TObject;chapter: Integer);
    procedure FilterGraphDVDCurrentHMSFTime(sender: TObject;HMSFTimeCode: tagDVD_HMSF_TIMECODE; TimeCode: tagDVD_TIMECODE);
    procedure PrevChapterButtonClick(Sender: TObject);
    procedure NextChapterButtonClick(Sender: TObject);
    procedure SpeedTrackBarChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure InfoButtonClick(Sender: TObject);
    procedure VolumeTrackBarChange(Sender: TObject);
    procedure SettingsButtonClick(Sender: TObject);
    procedure GetInfo();
    procedure ChooseAudioStream(Sender: TObject);
    procedure ChooseSubpictureStream(Sender: TObject);
    procedure Initialize();                       //set up video window size and saved settings
    procedure ReadSettings();
    procedure WriteSettings();
    procedure Subtitles1Click(Sender: TObject);
    procedure Audio1Click(Sender: TObject);
    procedure Chapters1Click(Sender: TObject);
    procedure GetDrives();
    procedure ChooseDrive(Sender: TObject) ;
    function  GetLanguage(LanguageID : Integer):string;
    function  GetVolumeName(DriveLetter : String) : string;
    procedure FormKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure VolumeTrackBarKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure DSTrackBarChange(Sender: TObject);
    function  FillZero(S : String; Len : byte) : String;
    procedure MuteButtonClick(Sender: TObject);
    procedure AudioButtonClick(Sender: TObject);
    procedure SubpictureButtonClick(Sender: TObject);
    procedure dsTrackbarMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure dsTrackbarMouseUp(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);  //Fills empty spaces with zeros(4 -> 04)
    procedure GoToNewLocation(NewTitleTime: TDVDHMSFTimeCode);
    function  EjectDrive(Drive : string): Boolean ;
    procedure ChooseDriveToEject(Sender : TObject);
    procedure WMDeviceChange(var Msg: TMessage); message WM_DEVICECHANGE;
    function  GetCDIcon(Drive : Char) : TIcon;
    procedure ToolButton7Click(Sender: TObject);
    procedure ChooseChapter(Sender : TObject);
    procedure ChapterButtonClick(Sender: TObject);
    procedure ChooseAngle(Sender : TObjecT);
    function  GetCurrentChapter():Cardinal;
    function  GetCurrentTitle():Cardinal;

    //  function MyThreadFunc(Ptr : Pointer) : LongInt; stdcall;
     //  TMyThread.Create(False);     //False = do not start thread in paused mode
   private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  SourceWidth,
  SourceHeight,
  SourceRatioX,
  SourceRatioY     : Word;
  SaveSettings     : Boolean;     //if false then prog does not save settings on Exit.
  TitleTime        : TDVDHMSFTimeCode;
  TimeCodeFlags    : ULONG;
  TitleTimeSeconds : Cardinal;
  //CurrentLocation  : TDVDPlaybackLocation2;
  ProgTitle        : String = 'A DVD Player';
  Mouse1Down       : Boolean;
  VolumeBeforeMute : Word;            //0..65535

type
  TGetDrivesThread = class(TThread)
  private
  protected
    procedure Execute; override;
    procedure GetDrives();
    function  GetVolumeName(DriveLetter: string): string;
end;

implementation

{$R *.dfm}
// GETDRIVESTHREAD begin =======================================================
procedure TGetDrivesThread.Execute;
begin
  //Synchronize(GetDrives);
  self.FreeOnTerminate := True;
  GetDrives();
end;

procedure TGetDrivesThread.GetDrives();              //this shows CD-roms too. fix that
var
  drivemap : DWORD;
  i, mask  : byte;
  root     : string;
  Drivelist : TStringlist;            //list of DVD (and CD) drives.
begin
  //this works fine, until exiting the prog. changing a prooperty on a component
  //on the MainForm from another thread makes it crash when exiting.
  MainForm.DrivesMenu.Items.Clear;
  MainForm.DrivesMenu.Items.Add(NewItem('Getting drive labels...',0,False,True,nil,0,'NoName'));
  MainForm.EjectDriveMenu.Items.Clear;
  MainForm.EjectDriveMenu.Items.Add(NewItem('Getting drive labels...',0,False,True,nil,0,'NoName'));
  Drivelist := TStringList.Create();
  DriveList.Clear;
  Root      := 'A:\';
  drivemap  := GetLogicalDrives;
  mask      := 1;
  for I := 1 to 32 do                    //32 drives should be maximum
  begin
    if (mask and drivemap) <> 0 then
    if GetDriveType(PChar(root)) = DRIVE_CDROM then begin
      DriveList.Add(Root +'  ['+GetVolumeName(Root)+']');
    end;
    Inc(mask);
    Inc(root[1]);          //makes 'A:\' to 'B:\'       (increments first character)
  end;
  MainForm.DrivesMenu.Items.Delete(0);     //  the  'Getting drive labels...'  item
  MainForm.EjectDriveMenu.Items.Delete(0);     //  the  'Getting drive labels...'  item

  if DriveList.Count < 1 then
    MainForm.Drivesmenu.Items.Add(NewItem('No drives found.',0,False,True,nil,0,'NoName'))
  else
  for I := 0 to Drivelist.Count-1 do begin
    MainForm.DrivesMenu.Items.Add(NewItem(Drivelist.Strings[I],0,False,True,Mainform.ChooseDrive,0,DriveList.Strings[I][1])); //The items name is the first character of the drive (E,F,K...). That makes it easy to play the DVD later
    MainForm.DrivesMenu.Items[I].Tag := I;                  //tag = id. to later be able to identify which item was clicked
    MainForm.DrivesMenu.Items[I].RadioItem := True;
    //=======
    MainForm.EjectDriveMenu.Items.Add(NewItem(Drivelist.Strings[I],0,False,True,Mainform.ChooseDriveToEject,0,DriveList.Strings[I][1])); //The items name is the first character of the drive (E,F,K...). That makes it easy to play the DVD later
    MainForm.EjectDriveMenu.Items[I].Tag := I;                  //tag = id. to later be able to identify which item was clicked
    MainForm.EjectDriveMenu.Items[I].RadioItem := True;
  end;
  SettingsForm.DefaultDVDDriveComboBox.Items.Clear;
  SettingsForm.DefaultDVDDriveComboBox.Items.AddStrings(DriveList);
  DriveList.Free;
end;

function  TGetDrivesThread.GetVolumeName(DriveLetter : String) : string;
//var
  //dummy: DWORD;
  //buffer: array[0..MAX_PATH] of Char;
//  i : word;
  //oldmode: LongInt;
begin              //see MainForm.GetVolumeName
  //oldmode := SetErrorMode(SEM_FAILCRITICALERRORS);       //what does this do?
  {
  try
    GetVolumeInformation(PChar(DriveLetter),buffer,SizeOf(buffer),nil,dummy,dummy,nil,0);

    Result := string(buffer);     //typecasting here
  finally
    //SetErrorMode(oldmode);
    ;
  end; }
end;
// GETDRIVESTHREAD end =========================================================
// MAINFORM begin ==============================================================
procedure TMAinForm.WMDeviceChange(var Msg: TMessage);
const DBT_DEVICEARRIVAL = $8000;         // system detected a new device
      DBT_DEVICEREMOVECOMPLETE = $8004;  // device is gone
var   myMsg: string;
begin 
  inherited;
  case Msg.wParam of
    DBT_DEVICEARRIVAL: myMsg  := 'CD inserted!';
    DBT_DEVICEREMOVECOMPLETE: myMsg := 'CD removed!';
  end;
  GetDrives();
end;

procedure TMainForm.PlayDVD(Sourcefile:WideString);
var   Status : TAMDVDRenderStatus;
      DVDCmd : IDVDCmd;
      HR     : HResult;
   //   pulActualSize : CArdinal;
    //  DVDDirectory : LPCWSTR;
  //    pullDiscID : Int64;
begin
  PreviewForm.Show;
  if not FilterGraph.Active then
  begin
    Filtergraph.Active := True;
    HR := Filtergraph.RenderDVD(Status,Sourcefile);
    if HR <> S_OK then
    begin
      case HR of
        HRESULT(E_INVALIDARG): Application.MessageBox('Invalid Argument.','Error', mb_ok);
        HRESULT(S_FALSE)     : begin
                        if Status.hrVPEStatus <> 0 then Application.MessageBox(PChar(GetErrorString(Status.hrVPEStatus)), 'Error', mb_OK);
                        if Status.bDvdVolInvalid   then Application.MessageBox('The specified DVD volume to be played does not exist.', 'Error', mb_OK);
                        if Status.bDvdVolUnknown   then Application.MessageBox('No DVD volume is specified or isn''t found.', 'Error', mb_OK);
                        if Status.bNoLine21In      then Application.MessageBox('The video decoder doesn''t produce line 21 (closed captioning) data.', 'Error', mb_OK);
                        if Status.bNoLine21Out     then Application.MessageBox('The video decoder can''t be shown as closed captioning on video due to a problem with graph building.', 'Error', mb_OK);
                        if status.iNumStreamsFailed > 0 then Application.MessageBox('Can''t render one or more stream.', 'Error', mb_OK);
                      end;
        HRESULT(VFW_E_DVD_DECNOTENOUGH) : Application.MessageBox('There isn''t enough hardware or software decoders to decode all streams.','Error', mb_OK);
        HRESULT(VFW_E_DVD_RENDERFAIL)   : Application.MessageBox('Some basic error occurred in building the graph.'#13'Possibilities include the DVD Navigator filter or the video or audio renderer not instantiating,'#13'a trivial connection or pin enumeration failing, or none of the streams rendering.','Error', mb_OK);
      end;   //case end
      FilterGraph.ClearGraph;
      //should the 3 following lines be here??
     // SpeedTrackbar.Position := 5;      //5 = play
     // GetInfo();                        //get resolution and stuff
     // Initialize();                     //set video window resolution and stuff
      exit;    //Exit procedure
    end;
    Filtergraph.Play;
    //Timer.Enabled := True;
    //MainForm.Caption := ProgTitle+'  '+GetVolumeName(
    with FilterGraph as IDVDControl2 do
    begin
      SetOption(DVD_NotifyParentalLevelChange,false); //not notify us when parental level changes
      SetOption(DVD_HMSF_TimeCodeEvents, true);       // use new HMSF timecode format
    end;
  end   //if not Filtergraph.active end
  else  //if Filtergraph is active (for example if it was paused)
  begin
    FilterGraph.Play;
    with FilterGraph as IDvdControl2 do PlayForwards(1.0,DVD_CMD_FLAG_None, DvdCmd);
    SpeedTrackbar.Position := 5;      //5 = play
    GetInfo();                        //get resolution and stuff
    Initialize();                     //set video window resolution and stuff
  end;
end;

procedure TMainForm.PlayButtonClick(Sender: TObject);
var  DefaultDrive : string;
begin
  toolbar.SetFocus;
  if not FilterGraph.Active then begin
    DefaultDrive := Trim(ExtractFileDrive(SettingsForm.DefaultDVDDriveComboBox.Text));    //get the Drive letter (F:,H:...)
    if DefaultDrive  <> '' then
      PlayDVD(DefaultDrive+'\VIDEO_TS\VIDEO_TS.IFO')
    else PlayDVD('');                                 //othervise open first available DVD
  end
  else PlayDVD('');            //if FilterGraph is Active (paused or playing) then resume
end;

procedure TMainForm.GetInfo();
var VideoAttributes    : TDVDVideoAttributes;
    AudioAttributes    : TDVDAudioAttributes;
   // VideoCompression : TDVDVideoCompression;
    AudioStreamsCount, CurrentAudioStream, AnglesCount, AudioLanguage,
    SubtitleStreamsCount, SubtitleLanguage, CurrentSubtitleStream,
    CurrentAngle       :  Cardinal;
    CurrentSubtitleDisabled : LongBool;
    I                  : byte;
//    LangStr            : array [0..255] of char;
    ChaptersCount      : Cardinal;
begin
  if not FilterGraph.Active then Exit;     //Exit procedure of no DVD files are opened
  InfoForm.InfoMemo.Clear;
   //Popupmenu items: 0:Audio, 1:Subtitles, 2:Angles, 3:Chapters, 4 : ...
  with FilterGraph as IDvdInfo2 do begin
   // GetCurrentLocation(PlaybackLocation);                //this is used for what?
    GetCurrentVideoAttributes(VideoAttributes);
    GetCurrentAudio(AudioStreamsCount,CurrentAudioStream);
    GetCurrentSubpicture(SubtitleStreamsCount,CurrentSubtitleStream,CurrentSubtitleDisabled);
    GetNumberOfChapters(GetCurrentTitle,ChaptersCount);

    GetCurrentAngle(AnglesCount,CurrentAngle);
    SourceWidth   := VideoAttributes.ulSourceResolutionX;
    SourceHeight  := VideoAttributes.ulSourceResolutionY;
    SourceRatioX  := VideoAttributes.ulAspectX;
    SourceRatioY  := VideoAttributes.ulAspectY;
    GetTotalTitleTime(TitleTime,TimeCodeFlags);       //result is in H:M:S:F format
    TitleTimeSeconds := titletime.bHours*60*60+titletime.bMinutes*60+titletime.bSeconds;
    DSTrackbar.Max :=  TitleTimeSeconds;

    PopupMenu.Items[0].Clear;   //Clear the Audio submenu before adding new items
    AudioButtonMenu.Items.Clear;
    if AudioStreamsCount > 0 then begin           //it will loop forever on next line if no streams are found
      for I := 0 to AudioStreamsCount-1 do begin
        GetAudioLanguage(I,AudioLanguage);             //gets the languageID from the stream
        Popupmenu.Items[0].Add(NewItem(GetLanguage(AudioLanguage),0,False,True,Mainform.ChooseAudioStream,0,'Audio'+IntToStr(I)));        //used my own list of languages to get language from languageID
        Popupmenu.Items[0].Items[I].Tag := I;               //tag = id. to later be able to identify which item was clicked
        Popupmenu.Items[0].Items[I].RadioItem := True;
        AudioButtonMenu.Items.Add(NewItem(GetLanguage(AudioLanguage),0,False,True,Mainform.ChooseAudioStream,0,'Audio'+IntToStr(I)));
        AudioButtonMenu.Items[I].Tag := I;
        AudioButtonMenu.Items[I].RadioItem := True;
      end;
    end;

    PopupMenu.Items[1].Clear;   //Clear the Subpicture submenu before adding new items
    SubpicButtonMenu.Items.Clear;
    if SubtitleStreamsCount > 0 then         //it will loop forever on next line if no streams are found
    for I := 0 to SubtitleStreamsCount -1 do begin
      //check this. does not look right
      GetSubpictureLanguage(I,SubtitleLanguage);    //gets the languageID from the stream
      if SubtitleLanguage < 1 then Continue;        //don't add items with ID 0. Occurs on some DVD's.
      Popupmenu.Items[1].Add(NewItem(GetLanguage(SubtitleLanguage),0,False,True,Mainform.ChooseSubpictureStream,0,'Subpicture'+IntToStr(I)));  //gets the language from the languageID and adds it to the menu
      Popupmenu.Items[1].Items[I].Tag := I;               //tag = id. to later be able to identify which item was clicked
      Popupmenu.Items[1].Items[I].RadioItem := True;
      SubpicButtonMenu.Items.Add(NewItem(GetLanguage(SubtitleLanguage),0,False,True,Mainform.ChooseSubpictureStream,0,'Subpicture'+IntToStr(I)));  //gets the language from the languageID and adds it to the menu
      SubpicButtonMenu.Items[I].Tag := I;
      SubpicButtonMenu.Items[I].RadioItem := True;
    end;

    PopupMenu.Items[2].Clear;   //Clear the Angle submenu before adding new items
    if AnglesCount > 0 then begin
      for I := 0 to AnglesCount-1 do begin
        PopupMenu.Items[2].Add(NewItem('Angle '+IntToStr(I+1),0,false,true,MainForm.ChooseAngle,0,'Angle'+IntToStr(I+1)));
        PopupMenu.Items[2].Items[I].Tag := I;
        Popupmenu.Items[2].Items[I].RadioItem := True;
        Popupmenu.Items[2].RadioItem := True;
      end;
    end;

    PopupMenu.Items[3].Clear;   //Clear the Chapter submenu before adding new items
    ChapterButtonMenu.Items.Clear;
    if ChaptersCount > 0 then begin
      for I := 0 to ChaptersCount-1 do begin
        Popupmenu.Items[3].Add(NewItem('Chapter '+IntToStr(I+1),0,False,True,MainForm.ChooseChapter,0,'Chapter'+IntToStr(I+1)));
        Popupmenu.Items[3].Items[I].Tag := I;
        Popupmenu.Items[3].Items[I].RadioItem := True;
        ChapterButtonMenu.Items.Add(NewItem('Chapter '+IntToStr(I+1),0,False,True,MainForm.ChooseChapter,0,'Chapter'+IntToStr(I+1)));
        ChapterButtonMenu.Items[I].Tag := I;
        ChapterButtonMenu.Items[I].RadioItem := True;
      end;
    end;

    InfoForm.InfoMemo.Lines.Add('Video resolution:'+#9+IntToStr(SourceWidth)+'x'+IntToStr(SourceHeight));
    InfoForm.InfoMemo.Lines.Add('Aspect ratio:'+#9+IntToStr(SourceRatioX)+':'+IntToStr(SourceRatioY));
    InfoForm.InfoMemo.Lines.Add('Letterboxed:'#9+BoolToStr(VideoAttributes.fIsSourceLetterboxed,True));
    InfoForm.InfoMemo.Lines.Add('Frame rate:'+#9+IntToStr(VideoAttributes.ulFrameRate)); {???}
    InfoForm.InfoMemo.Lines.Add('');
    InfoForm.InfoMemo.Lines.Add('Channels:'+#9#9+IntToStr(AudioAttributes.bNumberOfChannels));
    InfoForm.InfoMemo.Lines.Add('Quantization:'+#9+IntToStr(AudioAttributes.bQuantization));
    InfoForm.InfoMemo.Lines.Add('Sampling rate:'#9+IntToStr(AudioAttributes.dwFrequency div 1000)+ ' kHz');
    InfoForm.InfoMemo.Lines.Add('Audio streams:'+#9+IntToStr(AudioStreamsCount));
    InfoForm.InfoMemo.Lines.Add('Current stream:'+#9+IntToStr(CurrentAudioStream));  //does not seem correct
    InfoForm.InfoMemo.Lines.Add('');
    InfoForm.InfoMemo.Lines.Add('Angles:'+#9#9+IntToStr(AnglesCount));
    InfoForm.InfoMemo.Lines.Add('Current Angle:'+#9+IntToStr(CurrentAngle));
    InfoForm.InfoMemo.Lines.Add('Chapters:'+#9#9+IntToStr(ChaptersCount));
    InfoForm.InfoMemo.Lines.Add('Current chapter:'+#9+IntToStr(GetCurrentChapter));

    //AudioAttributes.LanguageExtension
    //AudioAttributes.AudioFormat
    //VideoCompression  := VideoAttributes.Compression;
    //GetSubpictureAttributes,GetDVDVolumeInfo,GetTitleAttributes,
  end;
end;

function TMainForm.GetLanguage(LanguageID : Integer): string;
begin
  case LanguageID of
    0     : Result := 'None';
    1025  : Result := 'Arabic (Saudi Arabia)';
    1026  : Result := 'Bulgarian';
    1027  : Result := 'Catalan';
    1028  : Result := 'Chinese (Taiwan)';
    1029  : Result := 'Czech';
    1030  : Result := 'Danish';
    1031  : Result := 'German (Germany)';
    1032  : Result := 'Greek';
    1033  : Result := 'English (United States)';
    1034  : Result := 'Spanish (Traditional)';
    1035  : Result := 'Finnish';
    1036  : Result := 'French (France)';
    1037  : Result := 'Hebrew';
    1038  : Result := 'Hungarian';
    1039  : Result := 'Icelandic';
    1040  : Result := 'Italian (Italy)';
    1041  : Result := 'Japanese';
    1042  : Result := 'Korean';
    1043  : Result := 'Dutch (Netherlands)';
    1044  : Result := 'Norwegian (Bokmal)';
    1045  : Result := 'Polish';
    1046  : Result := 'Portuguese (Brazil)';
    1047  : Result := 'Rhaeto-Romanic';
    1048  : Result := 'Romanian';
    1049  : Result := 'Russian';
    1050  : Result := 'Croatian';
    1051  : Result := 'Slovak';
    1052  : Result := 'Albanian';
    1053  : Result := 'Swedish';
    1054  : Result := 'Thai';
    1055  : Result := 'Turkish';
    1056  : Result := 'Urdu';
    1057  : Result := 'Indonesian';
    1058  : Result := 'Ukrainian';
    1059  : Result := 'Belarusian';
    1060  : Result := 'Slovenian';
    1061  : Result := 'Estonian';
    1062  : Result := 'Latvian';
    1063  : Result := 'Lithuanian';
    1064  : Result := 'Tajik';
    1065  : Result := 'Farsi';
    1066  : Result := 'Vietnamese';
    1067  : Result := 'Armenian';
    1068  : Result := 'Azeri (Latin)';
    1069  : Result := 'Basque';
    1070  : Result := 'Sorbian';
    1071  : Result := 'FYRO Macedonian';
    1072  : Result := 'Sesotho/Sutu';
    1073  : Result := 'Tsonga';
    1074  : Result := 'Tswana';
    1075  : Result := 'Venda';
    1076  : Result := 'Xhosa';
    1077  : Result := 'Zulu';
    1078  : Result := 'Afrikaans';
    1079  : Result := 'Georgian';
    1080  : Result := 'Faroese';
    1081  : Result := 'Hindi';
    1082  : Result := 'Maltese';
    1083  : Result := 'Sami Lappish';
    1084  : Result := 'Gaelic Scotland';
    1086  : Result := 'Malay (Malaysia)';
    1087  : Result := 'Kazakh';
    1088  : Result := 'Kyrgyz (Cyrillic)';
    1089  : Result := 'Swahili';
    1090  : Result := 'Turkmen';
    1091  : Result := 'Uzbek (Latin)';
    1092  : Result := 'Tatar';
    1093  : Result := 'Bengali';
    1094  : Result := 'Punjabi';
    1095  : Result := 'Gujarati';
    1096  : Result := 'Oriya';
    1097  : Result := 'Tamil';
    1098  : Result := 'Telugu';
    1099  : Result := 'Kannada';
    1100  : Result := 'Malayalam';
    1101  : Result := 'Assamese';
    1102  : Result := 'Marathi';
    1103  : Result := 'Sanskrit';
    1104  : Result := 'Mongolian (Cyrillic)';
    1105  : Result := 'Tibetan';
    1106  : Result := 'Welsh';
    1107  : Result := 'Khmer';
    1108  : Result := 'Lao';
    1109  : Result := 'Burmese';
    1110  : Result := 'Galician';
    1111  : Result := 'Konkani';
    1112  : Result := 'Manipuri';
    1113  : Result := 'Sindhi';
    1114  : Result := 'Syriac';
    1120  : Result := 'Kashmiri';
    1121  : Result := 'Nepali';
    1122  : Result := 'Frisian (Netherlands)';
    1125  : Result := 'Divehi';
    2049  : Result := 'Arabic (Iraq)';
    2052  : Result := 'Chinese (PRC)	';
    2055  : Result := 'German (Switzerland)';
    2057  : Result := 'English (United Kingdom)';
    2058  : Result := 'Spanish (Mexico)';
    2060  : Result := 'French (Belgium)';
    2064  : Result := 'Italian (Switzerland)';
    2067  : Result := 'Dutch (Belgium)';
    2068  : Result := 'Norwegian (Nynorsk)';
    2070  : Result := 'Portuguese (Portugal)';
    2072  : Result := 'Romanian (Moldova)';
    2073  : Result := 'Russian Moldova	';
    2074  : Result := 'Serbian (Latin)';
    2077  : Result := 'Swedish (Finland)';
    2092  : Result := 'Azeri (Cyrillic)';
    2108  : Result := 'Gaelic Ireland';
    2110  : Result := 'Malay (Brunei Darussalam)';
    2115  : Result := 'Uzbek (Cyrillic)';
    3073  : Result := 'Arabic (Egypt)';
    3076  : Result := 'Chinese (Hong Kong S.A.R.)';
    3079  : Result := 'German (Austria)';
    3081  : Result := 'English (Australia)';
    3082  : Result := 'Spanish (International)';
    3084  : Result := 'French (Canada)';
    3098  : Result := 'Serbian (Cyrillic)';
    4097  : Result := 'Arabic (Libya)';
    4100  : Result := 'Chinese (Singapore)';
    4103  : Result := 'German (Luxembourg)';
    4105  : Result := 'English (Canada)';
    4106  : Result := 'Spanish (Guatemala)';
    4108  : Result := 'French (Switzerland)';
    5121  : Result := 'Arabic (Algeria)';
    5124  : Result := 'Chinese (Macau S.A.R.)';
    5127  : Result := 'German (Liechtenstein)';
    5129  : Result := 'English (New Zealand)';
    5130  : Result := 'Spanish (Costa Rica)';
    5132  : Result := 'French (Luxembourg)';
    6145  : Result := 'Arabic (Morocco)';
    6153  : Result := 'English (Ireland)';
    6154  : Result := 'Spanish (Panama)';
    6156  : Result := 'French (Monaco)';
    7169  : Result := 'Arabic (Tunisia)';
    7177  : Result := 'English (South Africa)';
    7178  : Result := 'Spanish (Dominican Republic)';
    7180  : Result := 'French (West Indies)';
    8193  : Result := 'Arabic (Oman)';
    8201  : Result := 'English (Jamaica)';
    8202  : Result := 'Spanish (Venezuela)';
    9217  : Result := 'Arabic (Yemen)';
    9225  : Result := 'English (Caribbean)';
    9226  : Result := 'Spanish (Colombia)';
    9228  : Result := 'French (Congo, DRC)';
    10241 : Result := 'Arabic (Syria)';
    10249 : Result := 'English (Belize)';
    10250 : Result := 'Spanish (Peru)';
    10252 : Result := 'French (Senegal)';
    11265 : Result := 'Arabic (Jordan)	';
    11273 : Result := 'English (Trinidad)';
    11274 : Result := 'Spanish (Argentina)';
    11276 : Result := 'French (Cameroon)';
    12289 : Result := 'Arabic (Lebanon)';
    12297 : Result := 'English (Zimbabwe)';
    12298 : Result := 'Spanish (Ecuador)';
    12300 : Result := 'French (Cote d''Ivoire)';
    13313 : Result := 'Arabic (Kuwait)';
    13321 : Result := 'English (Philippines)';
    13322 : Result := 'Spanish (Chile)';
    13324 : Result := 'French (Mali)';
    14337 : Result := 'Arabic (U.A.E.)';
    14346 : Result := 'Spanish (Uruguay)';
    15361 : Result := 'Arabic (Bahrain)';
    15370 : Result := 'Spanish (Paraguay)';
    16385 : Result := 'Arabic (Qatar)';
    16394 : Result := 'Spanish (Bolivia)';
    17418 : Result := 'Spanish (El Salvador)';
    18442 : Result := 'Spanish (Honduras)';
    19466 : Result := 'Spanish (Nicaragua)';
    20490 : Result := 'Spanish (Puerto Rico)'
    else Result := 'Unknown ('+IntToStr(LanguageID)+')';
  end;
end;

procedure TMainForm.Initialize();
begin
  //if SettingsForm...SaveVideoWindowSize = True then ...   else begin
  if not SettingsForm.SavePreviewWindowSizeCheckbox.Checked then begin
    //try
    PreviewForm.ClientWidth  := SourceWidth;
    PreviewForm.ClientHeight := SourceHeight;
    //except on ESomeThingError do {Output to screen that somethings wrong}
  end;
end;

procedure TMainForm.StopButtonClick(Sender: TObject);
begin
  FilterGraph.ClearGraph;
  FilterGraph.Active := false;
end;

procedure TMainForm.PauseButtonClick(Sender: TObject);
begin
  Filtergraph.Pause;
end;

procedure TMainForm.FullScreenButtonClick(Sender: TObject);
begin
  if PreviewForm.VideoWindow.FullScreen = False then begin
    PreviewForm.VideoWindow.FullScreen := True;
    PreviewForm.MouseCursorTimer.Enabled := True;           //start timer to hide cursor in a few seconds
  end
  else begin
    PreviewForm.VideoWindow.FullScreen := False;
    PreviewForm.MouseCursorTimer.Enabled := False;          //not sure it this is needed. might be if PreviewWindow exits FullScreenMode before mouse cursor have been hidden.
  end;
  FullScreenButton.Down := PreviewForm.VideoWindow.FullScreen;
end;
{procedure TFormDVDPlayer.btFrameStepClick(Sender: TObject);
begin
  if FilterGraph.Active then
    with FilterGraph as IVideoFrameStep do Step(1,nil);
end;}

procedure TMainForm.RootMenuButtonClick(Sender: TObject);
var DvdCmd: IDvdCmd;
begin
  if FilterGraph.Active then
    with FilterGraph as IDvdControl2 do ShowMenu(DVD_MENU_Root, 0, DvdCmd);
end;

procedure TMainForm.TitleMenuButtonClick(Sender: TObject);
var DvdCmd: IDvdCmd;
begin
  if FilterGraph.Active then
    with FilterGraph as IDvdControl2 do ShowMenu(DVD_MENU_Title, DVD_CMD_FLAG_None, DvdCmd);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FilterGraph.ClearGraph;
  FilterGraph.Active := false;
  if SaveSettings = True then WriteSettings();    //if false then the values have been deleted from registry, so let's not save them.
end;

procedure TMainForm.WriteSettings();
var  Registry  : TRegistry;
begin
  Registry  := TRegistry.Create();
  Registry.RootKey := HKEY_LOCAL_MACHINE;
  Registry.OpenKey('Software\A DVD Player',True);    //True = create if it does not excist

  if SettingsForm.SavePreviewWindowSizeCheckBox.Checked = True then begin
    Registry.WriteBool('Save preview window size',True);
    Registry.WriteInteger('Preview window width',PreviewForm.VideoWindow.Width);
    Registry.WriteInteger('Preview window height',PreviewForm.VideoWindow.Height);
  end else Registry.WriteBool('Save preview window size',False);
  if SettingsForm.SaveWindowPositionsCheckBox.Checked then begin
    Registry.WriteBool('Save window positions',True);
    Registry.WriteInteger('Preview window x position',PreviewForm.Left);
    Registry.WriteInteger('Preview window y position',PreviewForm.Top);
    Registry.WriteInteger('Main window x position',MainForm.Left);
    Registry.WriteInteger('Main window y position',MainForm.Top);
  end else Registry.WriteBool('Save window positions',False);
end;

procedure TMainForm.ReadSettings();
var  Registry  : TRegistry;
begin
  //check if the values excists first!
  //and make changes to the SettingsForm too!!
  Registry  := TRegistry.Create();
  Registry.RootKey := HKEY_LOCAL_MACHINE;
  if Registry.KeyExists('Software\A DVD Player') then begin
    Registry.OpenKey('Software\A DVD Player',False);
    SaveSettings       := True;
    if Registry.ValueExists('Save preview window size') then begin
      PreviewForm.ClientWidth  := Registry.ReadInteger('Preview window width');
      PreviewForm.ClientHeight := Registry.ReadInteger('Preview window height');
      SettingsForm.SavePreviewWindowSizeCheckBox.Checked := True;
    end;
    if Registry.ValueExists('Save window positions') then
    if Registry.ReadBool('Save window positions') = True then begin
      PreviewForm.Left  := Registry.ReadInteger('Preview window x position');
      PreviewForm.Top   := Registry.ReadInteger('Preview window y position');
      MainForm.Left     := Registry.ReadInteger('Main window x position');
      MainForm.Top      := Registry.ReadInteger('Main window y position');
      SettingsForm.SaveWindowPositionsCheckBox.Checked := True;
    end;
    //SettingsForm.DefaultDVDDrive ...  := Registry.ReadString('Default DVD Drive');
    //if Registry.ReadBool('Save preview window x size') = True then
      //SettingsForm.                     := Registry.ReadInteger('Preview window width');
  end;                      //if Registry.KeyExists('Software\A DVD Player')...
  Registry.Free;
end;

procedure TMainForm.OpenButtonClick(Sender: TObject);
begin
  OpenDialog.Filter := 'VIDEO_TS.IFO|video_ts.ifo|IFO files (*.IFO)|*.ifo|Any file (*.*)|*.*';
  OpenDialog.FileName := 'VIDEO_TS.IFO';
  if OpenDialog.Execute then
  begin
    PreviewForm.Show;
    FilterGraph.ClearGraph;
    FilterGraph.Active := false;
    PlayDVD(OpenDialog.FileName);
  end;
end;

procedure TMainForm.FilterGraphDVDTitleChange(sender: TObject;title: Integer);
begin           
  TitleLabel.Caption := 'Title:  '+IntToStr(Title);
  FilterGraph.Play;                                //in case of fast forward.
  SpeedTrackbar.Position := 5;          //it's not done correctly if playing backwards. fix it.
  GetInfo();
  Initialize();
end;

procedure TMainForm.FilterGraphDVDChapterStart(sender: TObject;chapter: Integer);
begin
  ChapterLabel.Caption := 'Chapter: '+ inttostr(chapter);
end;                

procedure TMainForm.FilterGraphDVDCurrentHMSFTime(sender: TObject;HMSFTimeCode: tagDVD_HMSF_TIMECODE; TimeCode: tagDVD_TIMECODE);
begin
  with HMSFTimeCode do begin
    TimeLabel.Caption := FillZero(IntToStr(bHours),2)+':'+FillZero(IntToStr(bMinutes),2)+':'+FillZero(IntToStr(bSeconds),2)+'/'+FillZero(IntToStr(TitleTime.bHours),2)+':'+FillZero(IntToStr(TitleTime.bMinutes),2)+':'+FillZero(IntToStr(TitleTime.bSeconds),2);
    DSTrackbar.Position := bHours*60*60+bMinutes*60+bSeconds;
  end;
end;

function TMainForm.FillZero(S : String; Len : byte) : String;        //Fills empty spaces with zeros(4 -> 04)
begin
  While Length(S) < Len do S := '0'+S;
  Result := S;
end;

procedure TMainForm.PrevChapterButtonClick(Sender: TObject);
var DvdCmd: IDvdCmd;
begin
  if FilterGraph.Active then with FilterGraph as IDvdControl2 do PlayPrevChapter(DVD_CMD_FLAG_None, DvdCmd);
end;

procedure TMainForm.NextChapterButtonClick(Sender: TObject);
var DvdCmd: IDvdCmd;
begin
  if FilterGraph.Active then with FilterGraph as IDvdControl2 do PlayNextChapter(DVD_CMD_FLAG_None, DvdCmd);
end;

procedure TMainForm.SpeedTrackBarChange(Sender: TObject);
var DvdCmd: IDvdCmd;
    hr    : HResult;
begin
 { var  ACanvas: TCanvas;
  x1,y1,x2,y2 : Integer;
  inherited;
  ACanvas := TCanvas.Create;
  try
    ACanvas.Handle := GetWindowDC(MainForm.Handle);
    with ACanvas do  
    begin 
      Brush.Color := clActiveCaption;
      Font.Name := 'Tahoma';
      Font.Size := 8;
      Font.Color := clred;
      Font.Style := [fsItalic, fsBold];
      //TextOut(GetSystemMetrics(SM_CYMENU) + GetSystemMetrics(SM_CXBORDER),
      //  Round((GetSystemMetrics(SM_CYCAPTION) - Abs(Font.Height)) / 2) + 1, ' Some Text');
      x1 := SpeedTrackbar.Left;
      y1 := SpeedTrackbar.Top;
      x2 := x1+SpeedTrackbar.Width ;
      y2 := y1+SpeedTrackbar.Height ;
      ACanvas.Rectangle(x1+10,y1+37,x2-4,y2+19);
    end;
  finally
    ReleaseDC(MainForm.Handle, ACanvas.Handle);
    ACanvas.Free;
  end;
  }

  if FilterGraph.Active then
  begin
    if SpeedTrackbar.Position = 4 then begin
      FilterGraph.Pause;
      SpeedLabel.Caption := 'Paused'
    end
    else FilterGraph.Play;
    case SpeedTrackbar.Position of
      0 : begin
            with FilterGraph as IDvdControl2 do
              hr := PlayBackwards(8.0,DVD_CMD_FLAG_None, DvdCmd);
            //if hr =  then

            SpeedLabel.Caption := 'Speed: -8 x';
          end;
      1 : begin
            with FilterGraph as IDvdControl2 do
              hr := PlayBackwards(6.0,DVD_CMD_FLAG_None, DvdCmd);
            //if hr =

            SpeedLabel.Caption := 'Speed: -6 x';
          end;
      2 : begin
            with FilterGraph as IDvdControl2 do
              hr := PlayBackwards(4.0,DVD_CMD_FLAG_None, DvdCmd);
            //if hr =

            SpeedLabel.Caption := 'Speed: -4 x';
          end;
      3 : begin
            with FilterGraph as IDvdControl2 do
              PlayBackwards(2.0,DVD_CMD_FLAG_None, DvdCmd);
        //    if hr =
            SpeedLabel.Caption := 'Speed: -2 x';
          end;
      5 : begin
            with FilterGraph as IDvdControl2 do
              PlayForwards(1.0,DVD_CMD_FLAG_None, DvdCmd);
             //    if hr =
            SpeedLabel.Caption := 'Speed: 1 x';
          end;
      6 : begin
            with FilterGraph as IDvdControl2 do
              PlayForwards(2.0,DVD_CMD_FLAG_None, DvdCmd);
            if hr = VFW_E_DVD_OPERATION_INHIBITED then
              SpeedTrackbar.Position := 5                   //This procedure will call itself
            else SpeedLabel.Caption := 'Speed: 2 x';
          end;
      7 : begin
            with FilterGraph as IDvdControl2 do
              PlayForwards(4.0,DVD_CMD_FLAG_None, DvdCmd);
            //    if hr =
            SpeedLabel.Caption := 'Speed: 4 x';
          end;
      8 : begin
            with FilterGraph as IDvdControl2 do
              PlayForwards(6.0,DVD_CMD_FLAG_None, DvdCmd);
            //    if hr =
            SpeedLabel.Caption := 'Speed: 6x';
          end;
    end;
  end;      //if FilterGraph active
end;

procedure TMainForm.FormShow(Sender: TObject);
//var   GetDrivesThread  : TGetDrivesThread;
begin
  MainForm.ClientWidth := 670;
  MainForm.Caption := ProgTitle;
  Application.Title := ProgTitle;
  Application.HintHidePause := 7000;              //7 secs
  ReadSettings();                                 //read settings from registry.
  GetDrives();                                    //gets drive letters ( D:  E: F:)
  //GetDrivesThread :=  TGetDrivesThread.Create(False);  
end;

procedure TMainForm.InfoButtonClick(Sender: TObject);
begin
  InfoForm.Show;
end;

procedure TMainForm.VolumeTrackBarChange(Sender: TObject);
begin
  FilterGraph.Volume := VolumeTrackbar.Position;     //FilterGraph max volume = 10000
  VolumeLabel.Caption := 'Volume: '+IntToStr(FilterGraph.Volume div 100)+'%';
end;

procedure TMainForm.SettingsButtonClick(Sender: TObject);
begin
  SettingsForm.Show;
end;
   
procedure TMainForm.ChooseAudioStream(Sender: TObject);
var  ppCmd  : IDvdCmd;
begin
  with Sender as TMenuItem do
    with FilterGraph as IDvdControl2 do begin
      SelectAudioStream(Tag,0,ppCmd);                //TAG is from the menuitem
      Popupmenu.Items[0].Items[Tag].Checked := True;
    end;
end;

procedure TMainForm.ChooseSubpictureStream(Sender : TObject);
var  ppCmd : IDvdCmd;
begin
  with Sender as TMenuItem do
    with FilterGraph as IDvdControl2 do begin
      SelectSubpictureStream(Tag,0,ppCmd);
      Popupmenu.Items[1].Items[Tag].Checked := True;
    end;
end;

procedure TMainForm.ChooseChapter(Sender : TObject);
var  ppCmd  : IDvdCmd;
begin
  with Sender as TMenuItem do begin
    with FilterGraph as IDvdControl2 do begin
      PlayChapter(Tag,0,ppCmd);                  //Tag is from MenuItem
      Popupmenu.Items[3].Items[Tag].Checked := True;
    end;
  end;
end;

procedure TMainForm.ChooseAngle(Sender : TObject);
var   ppCmd : IDvdCmd;
begin
  with Sender as TMenuItem do
    with FilterGraph as IDvdControl2 do begin
      SelectAngle(Tag,0,ppCmd);
      Popupmenu.Items[2].Items[Tag].Checked := True;
    end;
end;

procedure TMainForm.Subtitles1Click(Sender: TObject);
var   ppCmd  : IDvdCmd;
begin
  with FilterGraph as IDvdControl2 do ShowMenu(DVD_MENU_SUBPICTURE,DVD_CMD_FLAG_None,ppCmd);
end;

procedure TMainForm.Audio1Click(Sender: TObject);
var   ppCmd  : IDvdCmd;
begin
  with FilterGraph as IDvdControl2 do ShowMenu(DVD_MENU_AUDIO,DVD_CMD_FLAG_None,ppCmd);
end;

procedure TMainForm.Chapters1Click(Sender: TObject);
var   ppCmd  : IDvdCmd ;
begin
  with FilterGraph as IDvdControl2 do ShowMenu(DVD_MENU_Chapter,DVD_CMD_FLAG_None,ppCmd);
end;

procedure TMainForm.GetDrives();
 var
  drivemap : DWORD;
  i, mask  : byte;
  root,
  VolumeName: string;
  Drivelist : TStringlist;            //list of DVD and CD drives.
begin
  MainForm.DrivesMenu.Items.Clear;
  MainForm.DrivesMenu.Items.Add(NewItem('Getting drive labels...',0,False,True,nil,0,'NoName'));
  MainForm.EjectDriveMenu.Items.Clear;
  MainForm.EjectDriveMenu.Items.Add(NewItem('Getting drive labels...',0,False,True,nil,0,'NoName'));
  Drivelist := TStringList.Create();
  DriveList.Clear;
  Root      := 'A:\';
  drivemap  := GetLogicalDrives;
  mask      := 1;
  for I := 1 to 32 do                    //32 drives should be maximum
  begin
    if (mask and drivemap) <> 0 then
    if GetDriveType(PChar(root)) = DRIVE_CDROM then begin
      VolumeName :=  GetVolumeName(Root);
      if VolumeName = '' then
        DriveList.Add(Root +'  '+GetVolumeName(Root))       //won't display  []  if drive has no label. that looks just stupid
      else
        DriveList.Add(Root +'  ['+GetVolumeName(Root)+']');
    end;
    Inc(mask);
    Inc(root[1]);          //makes 'A:\' to 'B:\'       (increments first character)
  end;
  MainForm.DrivesMenu.Items.Delete(0);     //  the  'Getting drive labels...'  item
  MainForm.EjectDriveMenu.Items.Delete(0);     //  the  'Getting drive labels...'  item

  if DriveList.Count < 1 then
    MainForm.Drivesmenu.Items.Add(NewItem('No drives found.',0,False,True,nil,0,'NoName'))
  else
  for I := 0 to Drivelist.Count-1 do begin
    MainForm.DrivesMenu.Items.Add(NewItem(Drivelist.Strings[I],0,False,True,Mainform.ChooseDrive,0,DriveList.Strings[I][1])); //The items name is the first character of the drive (E,F,K...). That makes it easy to play the DVD later
    MainForm.DrivesMenu.Items[I].Tag := I;                  //tag = id. to later be able to identify which item was clicked
    MainForm.DrivesMenu.Items[I].RadioItem := True;
    //maybe add a bitmap to the menu here
    //=======
    MainForm.EjectDriveMenu.Items.Add(NewItem(Drivelist.Strings[I],0,False,True,Mainform.ChooseDriveToEject,0,DriveList.Strings[I][1])); //The items name is the first character of the drive (E,F,K...). That makes it easy to play the DVD later
    MainForm.EjectDriveMenu.Items[I].Tag := I;                  //tag = id. to later be able to identify which item was clicked
    MainForm.EjectDriveMenu.Items[I].RadioItem := True;
  end;
  SettingsForm.DefaultDVDDriveComboBox.Items.Clear;
  SettingsForm.DefaultDVDDriveComboBox.Items.AddStrings(DriveList);
  DriveList.Free;
end;

procedure TMainForm.ChooseDrive(Sender : TObject);
begin
  //This was a pain in the ass to make it work. At first I did not know it was possible to
  //do it this way. To be able to use the TAG made it very simple.
  with Sender as TMenuItem do begin                                      //I don't understand this
    FilterGraph.ClearGraph;
    FilterGraph.Active := false;
    PlayDVD(DrivesMenu.Items[Tag].Name+':\VIDEO_TS\VIDEO_TS.IFO');  //the items name is the drive letter(E,F,I ...)
    DrivesMenu.Items[Tag].Checked := True;
    MainForm.Caption := ProgTitle+'  '+DrivesMenu.Items[Tag].Caption+'';
  end;
end;

function TMainform.GetVolumeName(DriveLetter: string): string;
var
  dummy: DWORD;
  buffer: array[0..MAX_PATH] of Char;
  //oldmode: LongInt;
begin
  //oldmode := SetErrorMode(SEM_FAILCRITICALERRORS);       //what does this do?
  try
    GetVolumeInformation(PChar(DriveLetter),buffer,SizeOf(buffer),nil,dummy,dummy,nil,0);
    Result := string(buffer);//StrPas(buffer);
  finally
    //SetErrorMode(oldmode);
    buffer := ' ';        //needs to be cleared. If next drive does not have a label then GetVolumeInformation will return the same label as the previous one.
  end;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
begin
 if (Shift = [ssAlt]) and (Key = 13) then begin
    MainForm.FullScreenButtonClick(Sender);               //does not work too good
    PreviewForm.VideoWindow.FullScreenTopMost := True;
  end;
end;

procedure TMainForm.FormMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
begin
  Mouse1Down   := TRue;
  ReleaseCapture;
  SendMessage(Self.Handle, WM_SYSCOMMAND, $F012, 0);
end;

procedure TMainForm.FormMouseWheel(Sender: TObject; Shift: TShiftState;WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  case SettingsForm.MouseWheelComboBox.ItemIndex of
    -1 : ;
    0  : begin                                                  //vindow size
           if WheelDelta < 0 then PreviewForm.ClientWidth := PreviewForm.ClientWidth+(WheelDelta div 4);//+WheelDelta here too because WheelDelta is negative!
           if WheelDelta > 0 then PreviewForm.ClientWidth := PreviewForm.ClientWidth+(WheelDelta div 4);
         end;
    1  : begin                                                         //speed
           if WheelDelta < 0 then SpeedTrackbar.Position := SpeedTrackbar.Position-1;
           if WheelDelta > 0 then SpeedTrackbar.Position := SpeedTrackbar.Position+1;
         end;
    2  : begin                                                        //volume
           if WheelDelta < 0 then VolumeTrackbar.Position := VolumeTrackbar.Position+WheelDelta;    //+WheelDelta here too because WheelDelta is negative!
           if WheelDelta > 0 then VolumeTrackbar.Position := VolumeTrackbar.Position+WheelDelta;
         end;
    3  : begin                                              //change chapter
           if WheelDelta < 0 then PrevChapterButton.Click;
           if WheelDelta > 0 then NextChapterButton.Click;
         end;
  end;
  Handled := True;        //makes sure that no other component uses the wheel function, for example move a trackbar
end;

procedure TMainForm.VolumeTrackBarKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
begin
  if key = VK_LEFT  then VolumeTrackbar.Position := VolumeTRackbar.Position-(VolumeTrackbar.Max div 101);
  if key = VK_RIGHT then VolumeTrackbar.Position := VolumeTRackbar.Position+(VolumeTrackbar.Max div 101);
end;

procedure TMainForm.FormMouseUp(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
begin
  Mouse1Down := False;
end;

procedure TMainForm.DSTrackBarChange(Sender: TObject);
var  NewTitleTime    : TDVDHMSFTimeCode;
     ppCmd           : IDvdCmd;
     CurrentLocation : TDVDPlaybackLocation2;
begin
  if (Mouse1Down) and (FilterGraph.Active) then begin
    //NewTitleTime := 0;
    NewTitleTime.bHours := DSTrackbar.Position div 3600;    //dsTrackbar.position is in seconds
    NewTitleTime.bMinutes := (DSTrackbar.Position-(NewTitleTime.bHours*3600)) div 60;
    NewTitleTime.bSeconds := DSTrackbar.Position-(NewTitleTime.bHours*3600)-(NewTitleTime.bMinutes*60);

    with FilterGraph as IDvdControl2 do
      //PlayAtTime(NewTitleTime,0,ppCmd);
      PlayAtTimeInTitle(0,NewTitleTime,0,ppCmd);
      //GoToNewLocation(NewTitleTime);
  end;
end;

procedure TMainForm.GoToNewLocation(NewTitleTime:TDVDHMSFTimeCode);
var   CurrentLocation  : TDVDPlaybackLocation2;
      ppCmd   : IDvdCmd;
begin
 { with FilterGraph as IDvdInfo2 do GetCurrentLocation(CurrentLocation); //to know which title you currently are in
  with Filtergraph as IDvdControl2 do
    PlayAtTimeInTitle(CurrentLocation.TitleNum,NewTitleTime,0,ppCmd);    }
end;

procedure TMainForm.MuteButtonClick(Sender: TObject);
begin
  if MuteButton.ImageIndex = 13 then begin      //14:icon muted, 13:icon not muted
    MuteButton.ImageIndex := 14;
    VolumeBeforeMute := FilterGraph.Volume;
    FilterGraph.Volume := 0;
    VolumeTrackbar.Position := 0;
    MuteButton.Down := True;
  end
  else begin
    MuteButton.ImageIndex := 13;
    if VolumeBeforeMute = 0 then VolumeBeforeMute := 10000;
    FilterGraph.Volume := VolumeBeforeMute;
    VolumeTrackbar.Position := FilterGraph.Volume;
    MuteButton.Down := False;
  end;
end;

procedure TMainForm.AudioButtonClick(Sender: TObject);
var   MousePos  : TPoint;
begin
  GetCursorPos(MousePos);
  AudioButtonMenu.Popup(MousePos.X,MousePos.Y);
end;

procedure TMainForm.SubpictureButtonClick(Sender: TObject);
var     MousePos  : TPoint;
begin
  GetCursorPos(MousePos);
  SubpicButtonMenu.Popup(mousePos.X,MousePos.Y);
end;

procedure TMainForm.dsTrackbarMouseDown(Sender: TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var  NewTitleTime : TDVDHMSFTimeCode;
begin
  if (Button = mbLeft) and (FilterGraph.Active) then begin
    Mouse1Down := True;
    NewTitleTime.bHours := DSTrackbar.Position div 3600;    //dsTrackbar.position is in seconds
    NewTitleTime.bMinutes := (DSTrackbar.Position-(NewTitleTime.bHours*3600)) div 60;
    NewTitleTime.bSeconds := DSTrackbar.Position-(NewTitleTime.bHours*3600)-(NewTitleTime.bMinutes*60);
    with FilterGraph as IDvdControl2 do
      GoToNewLocation(NewTitleTime);
  end;
end;

procedure TMainForm.dsTrackbarMouseUp(Sender: TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then Mouse1Down := False;
end;

procedure TMainForm.ChooseDriveToEject(Sender : TObject);
begin
  with Sender as TMenuItem do                                       //I don't understand this
    EjectDrive(EjectDriveMenu.Items[Tag].Name+':');                     //the items name is the drive letter(E,F,I ...)
end;

function TMainForm.EjectDrive(Drive: string): Boolean;
var
  Res: MciError;
  OpenParm: TMCI_Open_Parms;
  Flags: DWORD;
  DeviceID: Word;
begin
  Result := False;
  Flags  := MCI_OPEN_TYPE or MCI_OPEN_ELEMENT;
  with OpenParm do
  begin
    dwCallback := 0;
    lpstrDeviceType := 'CDAudio';
    lpstrElementName := PChar(Drive);
  end;
  Res := mciSendCommand(0, MCI_OPEN, Flags, Longint(@OpenParm));
  if Res <> 0 then Exit;
  DeviceID := OpenParm.wDeviceID;
  try
    Res := mciSendCommand(DeviceID, MCI_SET, MCI_SET_DOOR_OPEN, 0);   //
    //Res := mciSendCommand(DeviceID, MCI_SET, MCI_SET_DOOR_CLOSED, 0);
    if Res = 0 then Exit;
    Result := True;
  finally
    mciSendCommand(DeviceID, MCI_CLOSE, Flags, Longint(@OpenParm));
  end;
end;
            
function TMainForm.GetCDIcon(Drive: Char): TIcon;
var 
  ico: TIcon; 
  ini: TIniFile; 
  s, p: string; 
  i, j: Integer; 
begin
  //Abort if "AutoRun.inf" doesn't exists.
  if FileExists(Drive + ':\autorun.inf') = False then Exit;

  //Opens the "AutoRun.inf"
  ini := TIniFile.Create(Drive + ':\autorun.inf');
  ico := TIcon.Create;

  try
    //Read the filename
    s := ini.ReadString('Autorun', 'ICON', '');

    //Abort if there is no icon specified 
    if s = '' then Exit; 

    //load the icon from a file 
    if FileExists(s) then ico.LoadFromFile(s); 
    if FileExists(Drive + ':\' + s) then ico.LoadFromFile(Drive + ':\' + s); 

    //Load the icon from a Win32 resource 
    if (FileExists(s) = False) and (FileExists(Drive + ':\' + s) = False) then  
    begin 
      for j := (Pos(',', s) + 1) to Length(s) do  
      begin 
        p := p + s[j]; 
      end; 
      i := StrToInt(p); 
      for j := Length(s) downto (Pos(',', s)) do 
        Delete(s, j, Length(s));
      if FileExists(s) = False then s := Drive + ':\' + s;
      ico.Handle := ExtractIcon(hinstance, PChar(s), i);
    end;
    Result := ico; 
  finally 
    ini.Free; 
  end;
end; 

procedure TMainForm.ToolButton7Click(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.ChapterButtonClick(Sender: TObject);
var    MousePos : TPoint;
begin
  GetCursorPos(MousePos);
  ChapterButtonMenu.Popup(mousePos.X,MousePos.Y);
end;

function TMainForm.GetCurrentChapter(): Cardinal;
var       CurrentLocation : TDVDPlaybackLocation2;
begin
  with FilterGraph as  IDvdInfo2 do
    GetCurrentLocation(CurrentLocation);
    Result := CurrentLocation.ChapterNum
end;

function TMainForm.GetCurrentTitle():Cardinal;
var  CurrentLocation : TDVDPlaybackLocation2;
begin
  with FilterGraph as IDvdInfo2 do
    GetCurrentLocation(CurrentLocation);
    Result := CurrentLocation.TitleNum;
end;

end.

{convert ico to bmp:
  Bitmap.Height := Icon.Height;
  Bitmap.Width  := Icon.Width;
  Bitmap.Canvas.Draw(0, 0, Icon);
  Bitmap.savetofile...}
