unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DSPack, DirectShow9, ExtCtrls, StdCtrls;

type
  TPreviewForm = class(TForm)
    VideoWindow: TVideoWindow;
    MouseCursorTimer: TTimer;
    procedure VideoWindowDblClick(Sender: TObject);
    procedure VideoWindowMouseMove(Sender: TObject; Shift: TShiftState;X,Y: Integer);
    procedure VideoWindowMouseUp(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure VideoWindowKeyPress(Sender: TObject; var Key: Char);
    procedure VideoWindowKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MouseCursorTimerTimer(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VideoWindowMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PreviewForm: TPreviewForm;

implementation

uses Unit1;
{$R *.dfm}

procedure TPreviewForm.VideoWindowDblClick(Sender: TObject);
begin
  MainForm.FullScreenButtonClick(Sender);
end;

procedure TPreviewForm.VideoWindowMouseMove(Sender: TObject; Shift: TShiftState;X, Y: Integer);
var  Point : TPoint;
    //  t1,t2 : boolean;
begin
  if VideoWindow.FullScreen = True then begin
    VideoWindow.Cursor := crDefault;
    MouseCursorTimer.Enabled := False;
    MouseCursorTimer.Enabled := True;       //to reset the timer interval
    //  if PreviewForm.Cursor <> crDefault then PreviewForm.Cursor := crDefault;
  end;
  if MainForm.Filtergraph.Active then
  with MainForm.Filtergraph as IDvdControl2 do
  begin
    Point.X := x;
    Point.Y := y;
    SelectAtPosition(Point);
  end;
end;

procedure TPreviewForm.VideoWindowMouseUp(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
var Point : TPoint;
begin
  if MainForm.FilterGraph.Active then
    with MainForm.FilterGraph as IDvdControl2 do
    begin
      Point.x := x;
      Point.y := y;
      ActivateAtPosition(Point);
    end;
end;

procedure TPreviewForm.FormShow(Sender: TObject);
begin
  VideoWindow.FilterGraph  := MainForm.FilterGraph;
end;

procedure TPreviewForm.FormCloseQuery(Sender: TObject;var CanClose: Boolean);
begin
  MainForm.Close;
end;

procedure TPreviewForm.VideoWindowKeyPress(Sender: TObject; var Key: Char);
begin
  //MessageDlg(Key + ' has been pressed', mtInformation, [mbOK], 0)
  if Key = ' ' then begin
    if MainForm.FilterGraph.Pause = False then MainForm.PauseButtonClick(Sender)        //if pressing space bar
    else  MainForm.PlayButtonClick(Sender);
  end;
end;

procedure TPreviewForm.VideoWindowKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Shift = [ssAlt]) and (Key = 13) then begin
    MainForm.FullScreenButtonClick(Sender);               //does not work too good
    //VideoWindow.FullScreenTopMost := True;
  end;
end;

procedure TPreviewForm.MouseCursorTimerTimer(Sender: TObject);
begin
  VideoWindow.Cursor := crNone;                     //does not work!!  fix it
  MouseCursorTimer.Enabled := False;
end;

procedure TPreviewForm.FormMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  SendMessage(Self.Handle, WM_SYSCOMMAND, $F012, 0);
end;

procedure TPreviewForm.VideoWindowMouseDown(Sender: TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var Point : TPoint;
begin
  if MainForm.FilterGraph.Active then
    with MainForm.FilterGraph as IDvdControl2 do
    begin
      Point.x := x;
      Point.y := y;
      ActivateAtPosition(Point);
    end;
  //ReleaseCapture;
  //SendMessage(Self.Handle, WM_SYSCOMMAND, $F012, 0);
end;

end.
